leetCode 53.Maximum Subarray (子数组的最大和) 解题思路方法

Maximum Subarray

Find the contiguous subarray within an array (containing at least one number) which has the largest sum.

For example, given the array [?2,1,?3,4,?1,2,1,?5,4],

the contiguous subarray [4,?1,2,1] has the largest sum = 6.

click to show more practice.

More practice:

If you have figured out the O(n) solution, try coding another solution using the divide and conquer approach, which is more subtle.

思路:这题在刚開始想用双指针解,可是码代码的时候发现双指针不行,感觉不是非常难的一个题。最后还是要求助网上资料。经过翻找,一个非常好的博文详解了本题的算法思想。非常清晰,故摘录在下:

http://blog.csdn.net/joylnwang/article/details/6859677
又一个经典问题。对于一个包括负值的数字串array[1...n],要找到他的一个子串array[i...j](0<=i<=j<=n),使得在array的全部子串中。array[i...j]的和最大。

这里我们须要注意子串和子序列之间的差别。

子串是指数组中连续的若干个元素。而子序列仅仅要求各元素的顺序与其在数组中一致,而没有连续的要求。对于一个元素数为n的数组,其含有2^n个子序列和n(n+1)/2个子串。假设使用穷举法,则至少须要O(n^2)的时间才干得到答案。卡耐基梅隆大学的Jay Kadane的给出了一个线性时间算法,我们就来看看。怎样在线性时间内解决最大子串和问题。

要说明Kadane算法的正确性,须要两个结论。

首先。对于array[1...n],假设array[i...j]就是满足和最大的子串,那么对于不论什么k(i<=k<=j),我们有array[i...k]的和大于0。因为假设存在k使得array[i...k]的和小于0。那么我们就有array[k+1...j]的和大于array[i...j],这与我们假设的array[i...j]就是array中和最大子串矛盾。

其次,我们能够将数组从左到右切割为若干子串,使得除了最后一个子串之外,其余子串的各元素之和小于0,且对于全部子串array[i...j]和随意k(i<=k<j)。有array[i...k]的和大于0。

此时我们要说明的是。满足条件的和最大子串,仅仅能是上述某个子串的前缀。而不可能跨越多个子串。我们假设array[p...q]。是array的和最大子串,且array[p...q]。跨越了array[i...j],array[j+1...k]。依据我们的分组方式,存在i<=m<j使得array[i...m]的和是array[i...j]中的最大值,存在j+1<=n<k使得array[j+1...n]的和是array[j+1...k]的最大值。

因为array[m+1...j]使得array[i...j]的和小于0。此时我们能够比較array[i...m]和array[j+1...n]。假设array[i...m]的和大于array[j+1...n]则array[i...m]>array[p...q]。否array[j+1...n]>array[p...q]。不管谁大,我们都能够找到比array[p...q]和更大的子串。这与我们的假设矛盾。所以满足条件的array[p...q]不可能跨越两个子串。

对于跨越很多其它子串的情况,因为各子串的和均为负值。所以相同能够证明存在和更大的非跨越子串的存在。

对于单元素和最大的特例,该结论也适用。

依据上述结论,我们就得到了Kadane算法的运行流程,从头到尾遍历目标数组,将数组切割为满足上述条件的子串,同一时候得到各子串的最大前缀和,然后比較各子串的最大前缀和,得到终于答案。我们以array={?2, 1, ?3, 4, ?1, 2, 1, ?5, 4}为例,来简单说明一下算法步骤。通过遍历。能够将数组切割为例如以下3个子串(-2)。(1。-3),(4。-1,2,1,-5,4)。这里对于(-2)这种情况。单独分为一组。各子串的最大前缀和为-2,1,6,所以目标串的最大子串和为6。

我的代码,上面博文的代码有些繁琐。

public class Solution {
    public int maxSubArray(int[] nums) {
        int max = Integer.MIN_VALUE;//设置最小值
        int sum = 0;//每一个分组的和
        int i = 0;
        while(i < nums.length){
            sum += nums[i];//每一个分组的前n项和
            if(max < sum){
                max = sum;//取最大和
            }
            if(sum < 0){//假设<0。分组结束,開始下一组
                sum = 0;
            }
            i++;
        }
        return max;
    }
}
时间: 2024-10-17 07:18:07

leetCode 53.Maximum Subarray (子数组的最大和) 解题思路方法的相关文章

41. leetcode 53. Maximum Subarray

53. Maximum Subarray Find the contiguous subarray within an array (containing at least one number) which has the largest sum. For example, given the array [-2,1,-3,4,-1,2,1,-5,4], the contiguous subarray [4,-1,2,1] has the largest sum = 6. 思路:这个题还挺经典

LeetCode 53. Maximum Subarray(最大的子数组)

Find the contiguous subarray within an array (containing at least one number) which has the largest sum. For example, given the array [-2,1,-3,4,-1,2,1,-5,4],the contiguous subarray [4,-1,2,1] has the largest sum = 6. click to show more practice. Mor

[LeetCode] 53. Maximum Subarray 解题思路

Find the contiguous subarray within an array (containing at least one number) which has the largest sum. For example, given the array [-2,1,-3,4,-1,2,1,-5,4],the contiguous subarray [4,-1,2,1] has the largest sum = 6. 问题: 给定一个元素有正有负的数组,求最大连续子数组的和. 思路

leetcode 53 Maximum Subarray ----- java

Find the contiguous subarray within an array (containing at least one number) which has the largest sum. For example, given the array [−2,1,−3,4,−1,2,1,−5,4],the contiguous subarray [4,−1,2,1] has the largest sum = 6. 这道题就是求最大子串和 肯定是o(n)的时间和o(1)的空间 就

19.2.8 [LeetCode 53] Maximum Subarray

Given an integer array nums, find the contiguous subarray (containing at least one number) which has the largest sum and return its sum. Example: Input: [-2,1,-3,4,-1,2,1,-5,4], Output: 6 Explanation: [4,-1,2,1] has the largest sum = 6. Follow up: If

Leetcode 53 Maximum Subarray

public class S053 { //kadane's algorithm //最大子数组第一个数肯定大于零,从最大子数组中某个数开始往前的数之和肯定大于零 public int maxSubArray(int[] nums) { if(nums.length == 0) return 0; int sum = 0; int result = Integer.MIN_VALUE; for(int i =0;i<nums.length;i++){ if(sum<0) sum=0; sum+

LeetCode 53. Maximum Subarray 最大连续字段和问题

考察:最大连续字段和问题. 解决问题时间复杂度:O(n) 问题隐含条件:如果给出的数集都是负数,那么最大连续字段和就是,最大的那个负数. eg:{-2,-1}  结果应该输出 -1 而不是 0 int maxSubArray(int* nums, int numsSize) { int maxSum = 0; //维护最大连续字段和 int currentMaxSum = 0;//当前最大和 int nextNum = 0; int singleSum = nums[0]; //存在全是负数,则

LeetCode练题——53. Maximum Subarray

1.题目 53. Maximum Subarray——Easy Given an integer array nums, find the contiguous subarray (containing at least one number) which has the largest sum and return its sum. Example: Input: [-2,1,-3,4,-1,2,1,-5,4], Output: 6 Explanation: [4,-1,2,1] has th

【LeetCode】 Maximum Subarray

Find the contiguous subarray within an array (containing at least one number) which has the largest sum. For example, given the array [−2,1,−3,4,−1,2,1,−5,4], the contiguous subarray [4,−1,2,1] has the largest sum = 6. More practice: If you have figu